## gfal2 2.9.3

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message ("cmake source dir : ${CMAKE_SOURCE_DIR}")

# default set of options
set (MAIN_CORE      TRUE CACHE STRING "enable compilation of the main library")
set (MAIN_TRANSFER  TRUE CACHE STRING "enable compilation of the transfer library")
set (PLUGIN_LFC     TRUE CACHE STRING "enable compilation of the lfc plugin")
set (PLUGIN_SRM     TRUE CACHE STRING "enable compilation of the srm plugin")
set (PLUGIN_RFIO    TRUE CACHE STRING "enable compilation of the RFIO plugin")
set (PLUGIN_DCAP    TRUE CACHE STRING "enable compilation of the DCAP plugin")
set (PLUGIN_FILE    TRUE CACHE STRING "enable compilation of the local File plugin")
set (PLUGIN_GRIDFTP TRUE CACHE STRING "enable compilation of the GRIDFTP plugin")
set (PLUGIN_HTTP    TRUE CACHE STRING "enable compilation of the HTTP plugin")
set (PLUGIN_MOCK    FALSE CACHE STRING "enable compilation of the MOCK plugin")

# build type
set (CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "type of build")

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load modules
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)

# Enable C++11 support
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

# enable testing
include (CTest)

#define PROJECT vars
set (PROJECT_NAME_MAIN "gfal2")
set (OUTPUT_NAME_MAIN "gfal2")

set (PROJECT_NAME_TRANSFER "gfal_transfer")
set (OUTPUT_NAME_TRANSFER "gfal_transfer")

set (VERSION_MAJOR  2)
set (VERSION_MINOR  9)
set (VERSION_PATCH  3)
set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

add_definitions(-DVERSION="${VERSION_STRING}")

# out of project test compilation
set (ONLY_TESTS FALSE CACHE STRING "build only the tests")
set (SKIP_TESTS FALSE CACHE STRING "skip the tests")

# libs checks
find_package (GLIB2 REQUIRED)
find_package (GTHREAD2 REQUIRED)

# include directories
include_directories (${GLIB2_INCLUDE_DIRS})
include_directories (${GTHREAD2_INCLUDE_DIRS})
include_directories (${CMAKE_SOURCE_DIR}/src/core)
include_directories (${CMAKE_SOURCE_DIR}/src/utils)

# Core and plugins
if (NOT ONLY_TESTS)
    find_package (UUID REQUIRED)
    
    # general parameters for configuration
    add_definitions ( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
    add_definitions ( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )
    # add file offset 64 for 32 bits
    add_definitions ( -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_GNU_SOURCE)

    #install doc license
    install (FILES "LICENSE" "README" "RELEASE-NOTES" "DESCRIPTION" "readme.html"
			 DESTINATION ${DOC_INSTALL_DIR})
			
    # install global configuration files
    list (APPEND lst_conf_files "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gfal2_core.conf" "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/bdii.conf")
    install (FILES ${lst_conf_files}
             DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

    add_subdirectory (doc)
    add_subdirectory (src)

endif (NOT ONLY_TESTS)

if (NOT SKIP_TESTS)
    add_subdirectory (test)
endif (NOT SKIP_TESTS)

=== src/core/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

# Sources needed for the core library
file (GLOB src_cancel     "cancel/*.c*")
file (GLOB src_common     "common/*.c" "common/future/*.c")
file (GLOB src_config     "config/*.c")
file (GLOB src_exceptions "exceptions/*.c*")
file (GLOB src_gconfig    "g_config_manager/*.c*")
file (GLOB src_file       "file/*.c*")
file (GLOB src_global     "global/*c*")
file (GLOB src_logger     "logger/*.c*")
file (GLOB src_posix      "posix/*.c*")

# Core library
add_definitions(-D__GFAL2_BUILD__)

add_library (gfal2 SHARED ${src_cancel}
                          ${src_common}
                          ${src_config}
                          ${src_gconfig}
                          ${src_file}
                          ${src_global}
                          ${src_logger}
                          ${src_posix}
                          ${src_exceptions}
                          ${gfal2_utils_c_src})

target_link_libraries (gfal2 ${UUID_PKG_LIBRARIES} "stdc++" ) # hotfix for libc TLS init bug in EPEL 5
target_link_libraries (gfal2 ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES})
target_link_libraries (gfal2 "dl")

set_target_properties (gfal2 PROPERTIES
                             VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                             SOVERSION ${VERSION_MAJOR}
                             CLEAN_DIRECT_OUTPUT 1
                             OUTPUT_NAME ${OUTPUT_NAME_MAIN})

# pkgconfig for gfal2
add_PkgConfigFile_for_Library ("gfal2.pc" gfal2
                                        HEADER_DIRS "gfal2"
                                        CFLAGS " -D_FILE_OFFSET_BITS=64 "
                                        DESCRIPTION "GFAL 2.0 pkgconfig file"
                                        REQUIRES "glib-2.0")

# Install core library
install (TARGETS gfal2 LIBRARY DESTINATION ${LIB_INSTALL_DIR})
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal2.pc DESTINATION ${PKGCONFIG_FILES_DIR})

# Install development headers
install (FILES "gfal_api.h" "gfal_plugins_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/)
install (FILES "cancel/gfal_cancel.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/cancel)
install (FILES "logger/gfal_logger.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/logger)
install (FILES "posix/gfal_posix_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/posix)
install (FILES "common/gfal_constants.h"
               "common/gfal_common_plugin_interface.h"
               "common/gfal_prototypes.h"
               "common/gfal_common_plugin.h"
               "common/gfal_types.h"
               "common/gfal_deprecated.h"
               "common/gfal_common_err_helpers.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/common)
install (FILES "global/gfal_global.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)
install (FILES "config/gfal_config.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/config)
install (FILES "g_config_manager/g_config_manager.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/g_config_manager)
install (FILES "file/gfal_file_api.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/file)
install (FILES "fdesc/gfal_file_handle.h"
         DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/fdesc)

# Transfer library
if (MAIN_TRANSFER)
    add_subdirectory (transfer)
endif (MAIN_TRANSFER)

=== src/plugins/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

link_directories(${CMAKE_CURRENT_BINARY_DIR}/../core)

add_subdirectory (dcap)
add_subdirectory (file)
add_subdirectory (gridftp)
add_subdirectory (http)
add_subdirectory (lfc)
add_subdirectory (rfio)
add_subdirectory (srm)
add_subdirectory (mock)

=== test/common/CMakeLists.txt ===
add_library(test_shared SHARED gfal_lib_test.c gfal_gtest_asserts.cpp)
target_link_libraries (test_shared ${GFAL2_LIBRARIES} ${GTEST_LIBRARIES})

=== test/functional/CMakeLists.txt ===

if(FUNCTIONAL_TESTS)
        find_package(GTEST)

        include_directories(
            "${CMAKE_SOURCE_DIR}/src"
            "${CMAKE_SOURCE_DIR}/test"
            "${CMAKE_SOURCE_DIR}/src/posix/"
            "${GLIB2_INCLUDE_DIRS}"
            "${GTEST_INCLUDE_DIR}"
        )
        
        # Bring online tests
        add_executable(gfal_test_bringonline "gfal_test_bringonline.cpp")
        target_link_libraries(gfal_test_bringonline ${GFAL2_LIBRARIES} test_shared)
        
        function(test_bringonline name dir_path)
            add_test(gfal_test_bringonline_${name} gfal_test_bringonline ${dir_path})
        endfunction(test_bringonline name valid_file)

        # Checksum tests
        add_executable(gfal_test_checksum "gfal_test_checksum.cpp")
        target_link_libraries(gfal_test_checksum ${GFAL2_LIBRARIES} test_shared)
        
        function(checksum_test_simple name dir_path algo)
            add_test(gfal_checksum_simple_${name} gfal_test_checksum ${dir_path} ${algo})
        endfunction(checksum_test_simple name valid_file algo)
        
        # Stat tests
        add_executable(gfal_test_stat "gfal_test_stat.c")
        target_link_libraries(gfal_test_stat ${GFAL2_LIBRARIES} test_shared)
        
        function(stat_test_all name valid)
            add_test(gfal_stat_${name} gfal_test_stat ${valid})
        endfunction(stat_test_all valid)
        
        # Deletion tests
        add_executable(gfal_test_del_nonex "gfal_test_del_nonex.c")
        target_link_libraries(gfal_test_del_nonex ${GFAL2_LIBRARIES} test_shared)
        
        add_executable(gfal_test_del "gfal_test_del.cpp") 
        target_link_libraries(gfal_test_del ${GFAL2_LIBRARIES} test_shared)
        
        add_executable(gfal_test_mkdir_unlink "gfal_test_mkdir_unlink.c")
        target_link_libraries(gfal_test_mkdir_unlink ${GFAL2_LIBRARIES} test_shared)

        function(test_gfal_test_del_nonex name dir_path)
            add_test(gfal_test_del_nonex_${name} gfal_test_del_nonex ${dir_path})
        endfunction(test_gfal_test_del_nonex name path)        

        function(test_gfal_test_del name dir_path)
            add_test(gfal_test_del_${name} gfal_test_del ${dir_path})
        endfunction(test_gfal_test_del name path)        

        function (test_gfal_test_mkdir_unlink name dir_path)
            add_test(gfal_test_mkdir_unlink_${name} gfal_test_mkdir_unlink ${dir_path})
        endfunction (test_gfal_test_mkdir_unlink name path)        

        # Chmod tests
        add_executable(gfal_test_chmod "gfal_test_chmod.cpp")
        target_link_libraries(gfal_test_chmod ${GFAL2_LIBRARIES} test_shared)
        
        function(chmod_test_all name valid right1 right2 right3 right4)
            add_test(gfal_test_right_change_${name} gfal_test_chmod ${valid} ${right1} ${right2} ${right3} ${right4})
        endfunction(chmod_test_all name valid right1 right2 right3 right4)        
        
        # Rmdir tests
        add_executable(gfal_test_rmdir_full "gfal_test_rmdir_full.cpp")
        target_link_libraries(gfal_test_rmdir_full ${GFAL2_LIBRARIES} test_shared)

        function(rmdir_test_all name valid_dir)
            add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir})
        endfunction(rmdir_test_all name valid_dir)
        
        # Readdir tests
        add_executable(gfal_test_readdir_full "gfal_test_readdir_full.cpp")
        target_link_libraries(gfal_test_readdir_full ${GFAL2_LIBRARIES} test_shared)
        
        function(test_readdir_full name valid)
                add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
        endfunction(test_readdir_full valid)        

        # IO tests
        add_executable(gfal_test_rw_full "gfal_test_rw_full.cpp")
        target_link_libraries(gfal_test_rw_full ${GFAL2_LIBRARIES} test_shared)
            
        add_executable(gfal_test_rw_seq "gfal_test_rw_seq.cpp")
        target_link_libraries(gfal_test_rw_seq ${GFAL2_LIBRARIES} test_shared)
        
        add_executable(gfal_test_rw_seek "gfal_test_rw_seek.cpp")
        target_link_libraries(gfal_test_rw_seek ${GFAL2_LIBRARIES} test_shared) 
        
        function(rwt_test_all name path size)
            add_test(gfal_rw_size_${name} gfal_test_rw_full ${path} ${size})
        endfunction(rwt_test_all name path size)
        
        function(rwt_test_seq name path size_read size)
            add_test(gfal_rw_seq_${name} gfal_test_rw_seq ${path} ${size_read} ${size})
        endfunction(rwt_test_seq name path size_read size)
        
        function(rwt_test_seek name path size_read size)
            add_test(gfal_rw_seek_${name} gfal_test_rw_seek ${path} ${size_read} ${size})
        endfunction(rwt_test_seek name path size) 

        # Mkdir tests
        add_executable(gfal_test_mkdir_full "gfal_test_mkdir_full.cpp")
        target_link_libraries(gfal_test_mkdir_full ${GFAL2_LIBRARIES} test_shared)
        
        function(mkdir_test_all name prefix)
            add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
        endfunction(mkdir_test_all name prefix)    

        # Set credentials test
        add_executable(gfal_test_set_creds "gfal_test_set_creds.c")
        target_link_libraries(gfal_test_set_creds ${GFAL2_LIBRARIES})

        function(gfal_test_set_credentials name prefix)
            add_test(gfal_test_set_credentials_${name} gfal_test_set_creds ${prefix})
        endfunction(gfal_test_set_credentials name prefix)    

        # Tests for file transfer
        if(MAIN_TRANSFER)
                
                add_executable(gfalt_test_copy_file_cancel "gfalt_test_copy_file_cancel.cpp")
                target_link_libraries(gfalt_test_copy_file_cancel ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} pthread)
                
                add_executable(gfalt_test_copy_file "gfalt_test_copy_file.cpp")
                target_link_libraries(gfalt_test_copy_file ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)

                add_executable(gfalt_test_copy_file_thead_safety "gfalt_test_copy_file_thead_safety.cpp")
                target_link_libraries(gfalt_test_copy_file_thead_safety ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)

                add_executable(gfalt_test_copy_file_timeout "gfalt_test_copy_file_timeout.cpp")
                target_link_libraries(gfalt_test_copy_file_timeout ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)
                
                add_executable(gfalt_test_copy_file_mkdir "gfalt_test_copy_file_mkdir.cpp")
                target_link_libraries(gfalt_test_copy_file_mkdir ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)
                
                add_executable(gfalt_test_copy_file_replace "gfalt_test_copy_file_replace.cpp")
                target_link_libraries(gfalt_test_copy_file_replace ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)

                add_executable(gfalt_test_copy_file_checksum "gfalt_test_copy_file_checksum.cpp")
                target_link_libraries(gfalt_test_copy_file_checksum ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)

                add_executable(gfalt_test_copy_file_checksum_user "gfalt_test_copy_file_checksum_user.cpp")
                target_link_libraries(gfalt_test_copy_file_checksum_user ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)
                
                add_executable(gfalt_test_copy_bulk "gfalt_test_copy_bulk.cpp")
                target_link_libraries(gfalt_test_copy_bulk ${GFAL2_TRANSFER_LINK} ${GFAL2_LIBRARIES} test_shared)
                
                function(copy_file_test_full name src_dir dst_dir)
                    add_test(copyfile_checksum_${name} gfalt_test_copy_file_checksum ${src_dir} ${dst_dir})
                    add_test(copyfile_checksum_user_${name} gfalt_test_copy_file_checksum_user ${src_dir} ${dst_dir})
                    add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
                    add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
                    add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
                    add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
                endfunction(copy_file_test_full name dst_dir)

                function(copy_file_test_no_checksum name src_dir dst_dir)
                    add_test(copyfile_replace_${name} gfalt_test_copy_file_replace ${src_dir} ${dst_dir})
                    add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
                    add_test(copyfile_test_mkdir_${name} gfalt_test_copy_file_mkdir ${src_dir} ${dst_dir})
                    add_test(copyfile_bulk_${name} gfalt_test_copy_bulk ${src_dir} ${dst_dir})
                endfunction(copy_file_test_no_checksum name src_dir dst_dir)

                function(copy_file_test_simple name src_dir dst_dir)
                    add_test(copyfile_test_${name} gfalt_test_copy_file ${src_dir} ${dst_dir})
                endfunction(copy_file_test_simple name src_dir dst_dir)

        endif(MAIN_TRANSFER)

        include(functional-test-parameters.cmake)        
        
endif(FUNCTIONAL_TESTS)

=== test/unit/CMakeLists.txt ===
add_subdirectory(global)
add_subdirectory(cancel)
add_subdirectory(transfer)
add_subdirectory(uri)
add_subdirectory(plugins/srm)
#add_subdirectory(plugins/gridftp)

=== src/core/transfer/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (MAIN_TRANSFER)
        file (GLOB src_trans "*.c")
        list (APPEND header_transfer "gfal_transfer.h" "gfal_transfer_types.h" "gfal_transfer_plugins.h")

        add_definitions( ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS})

        add_library(gfal2_transfer  SHARED ${src_trans} ${gfal2_utils_src})
        target_link_libraries(gfal2_transfer ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES})
        target_link_libraries(gfal2_transfer ${UUID_PKG_LIBRARIES} ${OUTPUT_NAME_MAIN})

        set_target_properties(gfal2_transfer PROPERTIES
                                     LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src/core
                                     VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                                     SOVERSION ${VERSION_MAJOR}
                                     CLEAN_DIRECT_OUTPUT 1
                                     OUTPUT_NAME "gfal_transfer")
        add_PkgConfigFile_for_Library("gfal_transfer.pc" gfal2_transfer 
                                       HEADER_DIRS "gfal2"
                                       DESCRIPTION "gfal_transfer pkgconfig file"
                                       REQUIRES "gfal2")

        install(TARGETS gfal2_transfer
        LIBRARY DESTINATION ${LIB_INSTALL_DIR} )
            
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal_transfer.pc DESTINATION ${PKGCONFIG_FILES_DIR})
        install(FILES ${header_transfer} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/transfer)
        install(FILES "README_TRANSFER"
                DESTINATION ${DOC_INSTALL_DIR})

endif (MAIN_TRANSFER)

=== src/plugins/dcap/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_DCAP)
    file (GLOB src_dcap "*.c*")

    find_package(DCAP REQUIRED)
    include_directories(${DCAP_INCLUDE_DIR})

    add_definitions(-D_REENTRANT)
    add_definitions(${DCAP_CFLAGS})

    add_library(plugin_dcap SHARED ${src_dcap})

    target_link_libraries(plugin_dcap gfal2 ${DCAP_LIBRARIES})

    set_target_properties(plugin_dcap PROPERTIES   
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME "gfal_plugin_dcap"
                            LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    install(TARGETS plugin_dcap
            LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})

    install(FILES  "README_PLUGIN_DCAP"
            DESTINATION ${DOC_INSTALL_DIR})

    # install dcap configuration files
    LIST(APPEND dcap_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/dcap_plugin.conf")
    install(FILES ${dcap_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_DCAP)

=== src/plugins/file/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_FILE)
    file (GLOB src_file "*.c*")

    find_package (ZLIB REQUIRED)

    include_directories(${ZLIB_INCLUDE_DIRS})


    add_library (plugin_file SHARED ${src_file} ${gfal2_src_checksum})
    target_link_libraries (plugin_file gfal2 ${ZLIB_LIBRARIES})


    set_target_properties(plugin_file   PROPERTIES
                                LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME "gfal_plugin_file"
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    install(TARGETS		plugin_file
	        LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
	    
    install(FILES		"README_PLUGIN_FILE"
	    	DESTINATION ${DOC_INSTALL_DIR})	    

endif (PLUGIN_FILE)

=== src/plugins/gridftp/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

if (PLUGIN_GRIDFTP)
    file (GLOB_RECURSE src_gridftp "*.c*")

    find_package (Globus_GASS_COPY REQUIRED)

    add_definitions( ${GLOBUS_GASS_COPY_CFLAGS})
    add_library (plugin_gridftp SHARED ${src_gridftp})

    target_link_libraries(plugin_gridftp gfal2 gfal2_transfer
			              ${GLOBUS_GASS_COPY_LIBRARIES}
                          gomp
                          globus_gssapi_gsi)

    include_directories(${GLOBUS_GASS_COPY_INCLUDE_DIRS}) 

    set_target_properties(plugin_gridftp    PROPERTIES
								LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME "gfal_plugin_gridftp"
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)



    install(TARGETS		plugin_gridftp
	        LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
	    
    install(FILES		"README_PLUGIN_GRIDFTP"
	    	DESTINATION ${DOC_INSTALL_DIR})	    

    # install gsiftp configuration files
    LIST(APPEND gsiftp_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/gsiftp_plugin.conf")
    install(FILES ${gsiftp_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_GRIDFTP)

=== src/plugins/http/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_HTTP)
    include     (CheckLibraryExists)

    find_package(Davix REQUIRED)

    # Includes
    include_directories (${CMAKE_CURRENT_BINARY_DIR})
    include_directories(${DAVIX_INCLUDE_DIR})

    # definitions
    add_definitions (${DAVIX_CFLAGS})

    # Build plugin
    file (GLOB src_http "gfal_http_*.cpp")
    add_library (plugin_http SHARED ${src_http})

    target_link_libraries(plugin_http gfal2
          gfal2_transfer
          ${DAVIX_LIBRARIES}
    )

    set_target_properties(plugin_http   PROPERTIES  CLEAN_DIRECT_OUTPUT 1
                                        OUTPUT_NAME "gfal_plugin_http"
                                        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    # Install
    install(TARGETS plugin_http
            LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR})
    install(FILES "README_PLUGIN_HTTP"
            DESTINATION ${DOC_INSTALL_DIR})    

    # install http configuration files
    LIST(APPEND http_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/http_plugin.conf")
    install(FILES ${http_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_HTTP)

=== src/plugins/mock/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)


if (PLUGIN_MOCK)
    file (GLOB src_file "*.c*")

    add_library (plugin_mock SHARED ${src_file})
    target_link_libraries (plugin_mock gfal2 gfal2_transfer)


    set_target_properties(plugin_mock   PROPERTIES
                                LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME "gfal_plugin_mock"
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins)

    install(TARGETS		plugin_mock
	        LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR})
	    
    install(FILES		"README_PLUGIN_MOCK"
                DESTINATION ${DOC_INSTALL_DIR})

    # install mock configuration files
    LIST(APPEND mock_conf_file "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/mock_plugin.conf")
    install(FILES ${mock_conf_file}
                        DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

endif (PLUGIN_MOCK)

=== debian/changelog ===
gfal2 (2.9.3-2) unstable; urgency=medium

  * Remove hardcoded binary dependency on libdavix0 - based on patch
    from Ubuntu

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Thu, 13 Aug 2015 23:03:47 +0200

gfal2 (2.9.3-1) unstable; urgency=medium

  * New upstream release
  * Implement Multi-Arch support

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 31 Jul 2015 16:30:29 +0200

gfal2 (2.9.1-1) unstable; urgency=medium

  * New upstream release (Closes: #777874)
  * Drop gfal2-c++11.patch and gfal2-gfal_srm_contruct_key.patch
    (fixed upstream)

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Thu, 11 Jun 2015 17:22:57 +0200

gfal2 (2.8.4-1) unstable; urgency=medium

  * New upstream release
  * Drop gfal2-srm-patch-set-error.patch (fixed upstream)
  * Split out file plugin to its own package
  * Add new mock plugin package

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Thu, 09 Apr 2015 16:55:41 +0200

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, doxygen, libglib2.0-dev, libattr1-dev, libldap2-dev, uuid-dev, zlib1g-dev, liblfc-dev, libdpm-dev, srm-ifce-dev (>= 1.23.1), dcap-dev, libglobus-gass-copy-dev, davix-dev (>= 0.4.0), pkg-config, libgtest-dev
Standards-Version: 3.9.6
Section: net
Homepage: http://dmc.web.cern.ch/projects/gfal-2/home

Package: gfal2
Architecture: any
Multi-Arch: foreign
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gfal2-plugin-file (= ${binary:Version}), gfal2-plugin-lfc (= ${binary:Version}), gfal2-plugin-rfio (= ${binary:Version}), gfal2-plugin-dcap (= ${binary:Version}), gfal2-plugin-srm (= ${binary:Version}), gfal2-plugin-gridftp (= ${binary:Version}), gfal2-plugin-http (= ${binary:Version})
Description: Grid file access library 2.0
 GFAL 2.0 offers an a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 installed plugins.

Package: libgfal2-2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core of the Grid File access Library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2
Section: libs
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. It supports third-party copy.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libglib2.0-dev, libattr1-dev, ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2.

Package: gfal2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-file
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: libgfal2-2 (<< 2.8.4)
Breaks: libgfal2-2 (<< 2.8.4)
Description: Provides file support for gfal2
 Provides the file support (file://) for gfal2. The file plugin
 provides local file operations, as copying from local to remote or
 the other way around.

Package: gfal2-plugin-lfc
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides lfc support for gfal2
 Provides the lfc support (lfn://) for gfal2. The LFC plugin allows
 read-only POSIX operations for the LFC catalog.

Package: gfal2-plugin-rfio
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides rfio support for gfal2
 Provides the rfio support (rfio://) for gfal2. The rfio plugin
 provides the POSIX operations for the rfio URLs, the rfio protocol is
 used on the DPM and on the Castor storage systems.

Package: gfal2-plugin-dcap
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), dcap-tunnel-gsi, ${shlibs:Depends}, ${misc:Depends}
Description: Provides dcap support for gfal2
 Provides the dcap support (gsidcap://, dcap://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system.

Package: gfal2-plugin-srm
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libgfal-srm-ifce1 (>= 1.23.1), ${shlibs:Depends}, ${misc:Depends}
Description: Provides srm support for gfal2
 Provides the srm support (srm://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides the gridftp support for gfal2
 Provides the gridftp support (gsiftp://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.

Package: gfal2-plugin-http
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides HTTP and DAV support for gfal2
 Provides the HTTP (http[s]://) and WebDAV (dav[s]://) support for
 gfal2. This plugin is able to do third-party copy with WebDAV if the
 storage supports it.

Package: gfal2-plugin-mock
Architecture: any
Multi-Arch: same
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provides a mock dummy protocol for gfal2
 Provides a dummy mock:// protocol for gfal2.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

VERSION=2.9.3

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	ln -fs /usr/src/gtest test/gtest
	dh_auto_configure -- -DSYSCONF_INSTALL_DIR:PATH=/etc \
	   -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	   -DUNIT_TESTS=TRUE -DPLUGIN_MOCK=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	mkdir -p debian/gfal2-doc/usr/share/doc/gfal2-doc
	mv debian/tmp/usr/share/doc/gfal2/examples \
	   debian/tmp/usr/share/doc/gfal2/html \
	   debian/gfal2-doc/usr/share/doc/gfal2-doc
	rm -rf debian/tmp/usr/share/doc
	dh_install --fail-missing

override_dh_auto_clean:
	rm -f test/gtest
	dh_auto_clean

override_dh_auto_test:
	objdir=`ls -d obj-*` ; \
	export GFAL_PLUGIN_DIR=$(CURDIR)/$${objdir}/plugins ; \
	export GFAL_CONFIG_DIR=$(CURDIR)/$${objdir}/test/conf_test ; \
	dh_auto_test -- "ARGS+=-V"

get-orig-source:
	git clone https://gitlab.cern.ch/dmc/gfal2.git gfal2-$(VERSION)
	( cd gfal2-$(VERSION) ; \
	  git checkout v$(VERSION) ; \
	  git submodule init ; \
	  git submodule update \
	)
	tar -c -z --exclude-vcs -f ../gfal2_$(VERSION).orig.tar.gz gfal2-$(VERSION)
	rm -rf gfal2-$(VERSION)
